type NumberOrEmptyString<T extends boolean> = T extends true ? '' | number : number;
export declare const getNumberFromEnvParser: <AllowEmpty extends boolean = false>(envName: string, { allowEmptyString }?: {
    allowEmptyString?: AllowEmpty | undefined;
}) => () => NumberOrEmptyString<AllowEmpty>;
export declare const getStringFromEnvParser: (envName: string, { allowEmptyString, pattern, transform, }?: {
    allowEmptyString?: boolean | undefined;
    pattern?: string | undefined;
    transform?: ((value: string) => string) | undefined;
}) => () => string;
export declare const getStringEnumFromEnvParser: <T extends string, AllowEmpty extends boolean = false>(envName: string, possibleEnumValues: readonly T[], { allowEmptyString }?: {
    allowEmptyString?: AllowEmpty | undefined;
}) => () => AllowEmpty extends true ? "" | T : T;
type BoolOrEmptyString<T extends boolean> = T extends true ? '' | boolean : boolean;
export declare const getBoolFromEnvParser: <AllowEmpty extends boolean = false>(envName: string, { allowEmptyString }?: {
    allowEmptyString?: AllowEmpty | undefined;
}) => () => BoolOrEmptyString<AllowEmpty>;
export declare const getListFromEnvParser: <T = string>(envName: string, valueParser?: (arg: any) => T) => () => T[];
export declare const getEnvFromFileParser: (env: string, required?: boolean) => () => string;
export {};
